module Rcomic
  class Base
    def self.config(*kclasses)
      self.new.run(kclasses)
    end

    def run(kclasses)
      trace = TracePoint.new(:return) do |tp|
        commands = <<-RUBY
        local_variables.each do |variable|
          puts variable.to_s + " = " + eval(variable.to_s).inspect
        end
        instance_variables.each do |variable|
          puts variable.to_s + " = " + eval(variable.to_s).inspect
        end
        RUBY
        if kclasses.empty? || contain_classname?(kclasses, tp.defined_class)
          puts "--- #{tp.path}:#{tp.lineno} - #{tp.defined_class}##{tp.method_id}---"
          eval(commands, tp.binding)
        end
      end.enable
    end

    def contain_classname?(kclasses, kclass)
      result = kclasses.select { |kcl| kcl.to_s.include?(kclass.to_s) || kclass.to_s.include?(kcl.to_s) }
      !result.empty?
    end
  end
end
